/**
 * File:    Motors.h
 * Author:  David Zemon
 * Project: MS&T ITRSS... Segway?
 */

#ifndef MOTORS_H
#define MOTORS_H

#include <propeller.h>
#include <PropWare.h>

#define MOTORS_STATIONARY_PULSE		MILLISECOND + 500ULL*MICROSECOND

typedef struct {
	uint32_t leftMotor;
	uint32_t rightMotor;
} PWMDualMotors;

void PWMDualMotorsInit (PWMDualMotors *motors, const uint32_t leftMotorPin, const uint32_t rightMotorPin);

void PWMDualMotorsDrive (const PWMDualMotors *motors, const int16_t left, const int16_t right);

#endif /* MOTORS_H */
