/* File:    Segway_globals.c
 * 
 * Author:  David Zemon
 * Project: Segway
 */

// Includes
#include "Segway_globals.h"

uint8_t g_hardFault = 0;
int8_t g_leanAngle = 0; // Filtered angle from level that the platform is leaning
int8_t g_turnAngle = 0; // Filtered angle from vertical that the steering post is leaning

void error (const int8_t err, const PWMDualMotors *motors) {
	uint32_t val = err;

	g_hardFault = 1;

	GPIODirModeSet(BYTE_2, GPIO_DIR_OUT);

	// Shut down to the motors
	if (NULL != motors)
		PWMDualMotorsDrive(motors, 0, 0);

	val <<= 16;
	while (1) {
		GPIOPinWrite(DEBUG_LED, val);
		waitcnt(CNT + 200*MILLISECOND);
		GPIOPinClear(DEBUG_LED);
		waitcnt(CNT + 200*MILLISECOND);
	}
}
