/* File:    Segway_globals.h
 * 
 * Author:  David Zemon
 * Project: Segway
 */

#ifndef SEGWAY_GLOBALS_H_
#define SEGWAY_GLOBALS_H_

#include <propeller.h>
#include <sys/thread.h>
#include <PropWare.h>
#include "Motors.h"

#define DEBUG
//#define DEBUG_VERBOSE
//#define DEBUG_TIMING

/************************
 *** Global Constants ***
 ************************/
#define DEBUG_LED					BYTE_2

#define THREAD_STACK_SIZE			128		// NOTE: Thread space defined in terms of uint32_t, NOT bytes/uint8_t

/************************
 *** Global Variables ***
 ************************/
extern uint8_t g_hardFault;
extern int8_t g_leanAngle;
extern int8_t g_turnAngle;

// Segway error codes - counting backward! (Leave -1 for uninitialized error codes)
#define NEED_REAL_ERROR_CODE		-1
#define FLAT_ON_FACE				-2
#define FORGOT_TO_IMPLEMENT_FILTER	-3

/*****************************
 *** Function Declarations ***
 *****************************/
void error (const int8_t err, const PWMDualMotors *motors);

#endif /* SEGWAY_GLOBALS_H_ */
